<!-- wip -->
<div class="nitro">
	<div class="row justify-content-center">
		<div class="col-md-8 col-sm-12 col-lg-4">
			<div class="card">
				<h2 class="text-center p-3">
					<div class="p-1">
						<img src="https://nitropack.io/asset/img/icov6.png" width="52" id="nitropack-logo" alt="NitroPack.io">
					</div>
					<div class="p-1">
						<span class="opacity-0-9">NitroPack</span> <span class="opacity-0-2">/ IO</span>
					</div>
        		</h2>
				<div class="card-body card-welcome">
					<div id ="nitropack-alert-welcome" class="alert alert-light bg-light alert-welcome">
						<h4 class="text-center">Welcome to NitroPack.io!</h4>
						<hr>
						<p class="my-4">Please go to <a href="https://nitropack.io/pricing" target="_blank"><strong>nitropack.io&nbsp;<sup><small><i class="fa fa-external-link"></i></small></sup></strong></a> and register your site.</p>
						<p>Then copy your Site ID and Site Secret, and put them below. <a class="no-break" href="https://nitropack.io/blog/post/how-to-get-your-site-id-and-site-secret" target="_blank">See how&nbsp;<sup><small><i class="fa fa-external-link"></i></small></sup></a></p>
					</div>

					<div id="nitropack-alert-error" class="alert alert-light bg-light alert-welcome" style="display:none;">
						<h4 class="text-center">There was an error</h4>
						<p id="nitropack-error-message" class="my-4"></p>
					</div>

					<div id="nitropack-info-div" class="nitropack-focus-veil" style="display:none;">
						<p class="nitropack-centered"></p>
						<span><i class="fa fa-close"></i></span>
					</div>

					<form enctype="multipart/form-data" id="connect-form">
						<div class="form-group">
							<label for="select-store">Selected Store View</label>
							<div>
								<input type="text" class="form-control" disabled id="select-store" name="store_id" value="<?= $block->getStoreName() ?>: <?= $block->getStoreUrl() ?>" />
							</div>
						</div>
						<div class="form-group">
							<label for="input-site-id">Put Your Site ID</label>
							<div class="input-group">
								<input type="text" class="form-control" id="nitro_site_id" name="nitro_site_id" placeholder="Site ID" />
							</div>
	        			</div>
						<div class="form-group">
							<label for="input-site-id">Put Your Site Secret</label>
							<div class="input-group">
								<input type="password" class="form-control" id="nitro_site_secret" name="nitro_site_secret" placeholder="Site Secret" data-toggle-password="" />
								<div class="input-group-append">
									<span class="btn btn-outline-secondary" id="toggle-password">
										<i class="fa fa-eye"></i>
									</span>
								</div>
							</div>
						</div>
					</form>
				</div>
				<div id="nitropack-site-connect" class="text-center pb-5 pt-3">
					<button class="btn btn-primary btn-lg" id="nitro_connect">Connect Your Site</button>
				</div>
				<div id="nitropack-error-close" class="text-center pb-5 pt-3" style="display:none;">
					<button class="btn btn-primary btn-lg" id="nitro_error_close">Close</button>
				</div>
			</div>
		</div>
	</div>
</div>
<script type="text/javascript">

function preg_match(re, val) {
  return (new RegExp(re).test(val));
}

require(['jquery'], function($) {
	let saveUrl = '<?= $block->getSaveUrl() ?>';

	$(document).ready(function() {
		$('#nitro_connect').click(submitForm);
	});

	function validationError(field, message) {
		let infoElement = $('#nitropack-info-div');
		let fieldElement = $(field);

		infoElement.children('p').html(message);
		infoElement.detach().prependTo(fieldElement.parent());
		infoElement.on('click', function(e){infoElement.hide();});
		infoElement.show();
	}

	function displayError(errorHtml) {
		$('#connect-form').hide();
		$('#nitropack-error-message').html(errorHtml);
		$('#nitropack-alert-error').show();
		$('#nitropack-site-connect').hide();
		$('#nitropack-error-close').show();
	}

	function submitForm(event) {
		event.preventDefault();

		if ($('#nitro_site_id').val() == '') {
			validationError('#nitro_site_id', 'Site ID field cannot be blank. <a class="text-white pl-2 pr-2" href="https://nitropack.io/blog/post/how-to-get-your-site-id-and-site-secret" target="_blank">See how&nbsp;<sup><small><i class="fa fa-external-link"></i></small></sup></a> to get yours.');
			return;
		}
		if (!preg_match('^([a-zA-Z]{32})$', $('#nitro_site_id').val())) {
			validationError('#nitro_site_id', 'Invalid site ID');
			return;
		}

		if ($('#nitro_site_secret').val() == '') {
			validationError('#nitro_site_secret', 'Site secret field cannot be blank. <a class="text-white pl-2 pr-2" href="https://nitropack.io/blog/post/how-to-get-your-site-id-and-site-secret" target="_blank">See how&nbsp;<sup><small><i class="fa fa-external-link"></i></small></sup></a> to get yours.');
			return;
		}
		if (!preg_match('^([a-zA-Z0-9]{64})$', $('#nitro_site_secret').val())) {
			validationError('#nitro_site_secret', 'Invalid site secret');
			return;
		}

		$.ajax({
			url: saveUrl,
			method: 'POST',
			dataType: 'json',
			data: {
				nitro_site_id: $('#nitro_site_id').val(),
				nitro_site_secret: $('#nitro_site_secret').val()
			},
			success: connectSuccess,
			error: connectError
		});
	}

	function connectSuccess(response) {
		if (response.connected) {
			window.location = response.redirect;
		} else {
			let errorHtml = '<strong>Message: </strong>'+response.errors;
			displayError(errorHtml);
		}
	}

	function connectError(response, errType, msg) {
		let errorHtml = "Type: " + errType + "<br/>Message:" + msg;
		displayError(errorHtml);
	}

	$('#nitropack-error-close').on('click', function(e) {
		$('#nitropack-error-close').hide();
		$('#nitropack-alert-error').hide();
		$('#connect-form').show();
		$('#nitropack-site-connect').show();

	});

	$(document).on('click', '#toggle-password', function(e) {
			let target = $(this).closest('.form-group').find('input[data-toggle-password]');

			if ($(target).attr('type') == 'password') {
					$(target).attr('type', 'text');
					$(this).find('.fa-eye').removeClass('fa-eye').addClass('fa-eye-slash');
			} else {
					$(target).attr('type', 'password');
					$(this).find('.fa-eye-slash').removeClass('fa-eye-slash').addClass('fa-eye');
			}
	});

	$(document).on('click', '[data-loading-text]', function(e) {
			$(this).addClass('disabled');
			$(this).text($(this).attr('data-loading-text'));
	});
});
</script>
